package com.example.java17Example;

import org.springframework.boot.autoconfigure.SpringBootApplication;


/*
Enhanced Performance: It can vary based on the specific use case, workload, and application design.
It's always recommended to profile and benchmark your application to identify performance bottlenecks and
choose the appropriate optimizations based on your requirements.

Sealed Classes and Interfaces: By using sealed classes and interfaces, you can better control the class hierarchy and ensure that only
specific subclasses or implementing classes are allowed,
improving code maintainability and robustness.

 Record classes :Records are a powerful tool for  creating simple,
 data-centric classes without boilerplate code for getters, setters, equals, hashCode, and toString methods.

 patternMatching for instanceOf:instanceof Pattern: This pattern is used to match an object's type against a specific class or interface, and it can bind the matched object to a pattern variable.

Pattern matching improves code readability and maintainability by eliminating the need for boilerplate code like type casting and
 providing a more natural and structured way to handle different cases based on the structure or properties of the data.

 pattern matching for switchExpression :The switch expression is enhanced to allow patterns in the case labels.
 This enables matching against different patterns and binding matched values to pattern variables.




 */

@SpringBootApplication
public class Java17ExampleApplication {

	public static void main(String[] args) {

	}
}
