package com.example.java17Example;

/*
Sealed classes and interfaces enable you to define a specific set of subclasses that can extend or implement them,
providing more control over the inheritance hierarchy and allowing for better code structure and maintenance.
we have a sealed class Student that permits two subclasses: UndergraduateStudent and GraduateStudent.
 The subclasses inherit from the sealed class Student.
  The UndergraduateStudent class has an additional field for the academic year,
  while the GraduateStudent class has a field for the research topic.
In the SealedClassExample class, we create instances of both subclasses and print their details.
 */

public class SealedClassExample {
    public static void main(String[] args) {
        UndergraduateStudent undergradStudent = new UndergraduateStudent("Alice", 1001, 2);
        System.out.println("Undergraduate Student: " + undergradStudent.getName() +
                ", Student ID: " + undergradStudent.getStudentId() +
                ", Year: " + undergradStudent.getYear());

        GraduateStudent gradStudent = new GraduateStudent("Bob", 2001, "Computer Science");
        System.out.println("Graduate Student: " + gradStudent.getName() +
                ", Student ID: " + gradStudent.getStudentId() +
                ", Research Topic: " + gradStudent.getResearchTopic());
    }
}
