package com.example.java17Example;

public sealed class Student permits UndergraduateStudent, GraduateStudent {
    private String name;
    private int studentId;

    public Student(String name, int studentId) {
        this.name = name;
        this.studentId = studentId;
    }

    public String getName() {
        return name;
    }

    public int getStudentId() {
        return studentId;
    }
}
final class UndergraduateStudent extends Student {
    private int year;

    public UndergraduateStudent(String name, int studentId, int year) {
        super(name, studentId);
        this.year = year;
    }

    public int getYear() {
        return year;
    }
}
final class GraduateStudent extends Student {
    private String researchTopic;

    public GraduateStudent(String name, int studentId, String researchTopic) {
        super(name, studentId);
        this.researchTopic = researchTopic;
    }

    public String getResearchTopic() {
        return researchTopic;
    }
}
